# Gridlock - a collection of grid-based strategy games
# Copyright (c) 2009 Brian Nenninger (brian@dozingcatsoftware.com)
# Gridlock comes with ABSOLUTELY NO WARRANTY, and is released under version 3 of the GNU GPL.

import Concentration
import PGOpenGLUtils

COLORS = ((0.2,0.2,0.2,0.5),(0,0,1,0.5),(0,1,0,0.5),(0,1,1,0.5),(1,0,0,0.5),(1,0,1,0.5),(1,1,0,0.5),(1,1,1,0.5))
    
DRAW_FUNCTIONS = (PGOpenGLUtils.draw_sphere, PGOpenGLUtils.draw_cube, PGOpenGLUtils.draw_torus, PGOpenGLUtils.draw_diamond)

def drawCell(state, coord, value, scale):
    if value<Concentration.MAX_PIECES:
        PGOpenGLUtils.draw_wall(scale/2, flat=(len(coord)==2))
    else:
        color = COLORS[value % len(COLORS)]
        func = DRAW_FUNCTIONS[(value % Concentration.MAX_PIECES) // len(COLORS)]
        func(scale=scale, color=color)
    return True
