# Gridlock - a collection of grid-based strategy games
# Copyright (c) 2009 Brian Nenninger (brian@dozingcatsoftware.com)
# Gridlock comes with ABSOLUTELY NO WARRANTY, and is released under version 3 of the GNU GPL.

GAMES = [
    {'name': 'Ataxx',
     'variations': [{'name':'Standard', 'params':{'dimensions':(7,7), 'positions':{'1':((0,0),(6,6)), '2':((0,6),(6,0)), }}},
                    {'name':'Random', 'params':{'dimensions':(7,7), 'random_walls': 8, 'positions':{'1':((0,0),(6,6)), '2':((0,6),(6,0)), }}},
                    {'name':'Cross', 'params':{'dimensions':(7,7), 'positions':{'1':((0,0),(6,6)), '2':((0,6),(6,0)), '-1':((3,3),(3,4),(3,2),(2,3),(4,3)), }}},
                    {'name':'Diamond', 'params':{'dimensions':(7,7), 'positions':{'1':((0,0),(6,6)), '2':((0,6),(6,0)), '-1':((3,5),(3,1),(5,3),(1,3),(4,4),(4,2),(2,4),(2,2)), }}},
                    {'name':'Bridge', 'params':{'dimensions':(7,7), 'positions':{'1':((0,0),(6,6)), '2':((0,6),(6,0)), '-1':((3,0),(3,1),(3,2),(3,4),(3,5),(3,6)), }}},
                    {'name':'Quadrants', 'params':{'dimensions':(7,7), 'positions':{'1':((0,0),(6,6)), '2':((0,6),(6,0)), '-1':((3,0),(3,1),(3,2),(3,4),(3,5),(3,6),(0,3),(1,3),(2,3),(4,3),(5,3),(6,3)), }}},
                    {'name':'Moat', 'params':{'dimensions':(7,7), 'positions':{'1':((0,0),(6,6)), '2':((0,6),(6,0)), '-1':((1,1),(1,2),(1,3),(1,4),(1,5),(5,1),(5,2),(5,3),(5,4),(5,5),(2,1),(3,1),(4,1),(5,1),(2,5),(3,5),(4,5),(5,5)), }}},
                    {'name':'Courtyard', 'params':{'dimensions':(7,7), 'positions':{'1':((0,0),(6,6)), '2':((0,6),(6,0)), '-1':((1,1),(1,2),(1,4),(1,5),(5,1),(5,2),(5,4),(5,5),(2,1),(4,1),(5,1),(2,5),(4,5),(5,5)), }}},
                    {'name':'Streets', 'params':{'dimensions':(7,7), 'positions':{'1':((0,0),(6,6)), '2':((0,6),(6,0)), '-1':((1,1),(1,3),(1,5),(3,1),(3,3),(3,5),(5,1),(5,3),(5,5)), }}},
                    {'name':'X', 'params':{'dimensions':(7,7), 'positions':{'1':((0,0),(6,6)), '2':((0,6),(6,0)), '-1':((1,1),(2,2),(3,3),(4,4),(5,5),(1,5),(2,4),(4,2),(5,1)), }}},
                    {'name':'Slash', 'params':{'dimensions':(7,7), 'positions':{'1':((0,0),(6,6)), '2':((0,6),(6,0)), '-1':((1,1),(2,2),(3,3),(4,4),(5,5)), }}},
                    {'name':'Arena', 'params':{'dimensions':(7,7), 'positions':{'1':((0,0),(6,6)), '2':((0,6),(6,0)), '-1':((0,2),(0,3),(0,4),(6,2),(6,3),(6,4),(2,0),(3,0),(4,0),(2,6),(3,6),(4,6),(1,5),(5,1),(1,1),(5,5)), }}},
                    {'name':'Eyes', 'params':{'dimensions':(7,7), 'positions':{'1':((0,0),(6,6)), '2':((0,6),(6,0)), '-1':((0,1),(1,1),(1,0),(5,0),(5,1),(6,1),(0,5),(1,5),(1,6),(5,6),(5,5),(6,5),(2,2),(2,3),(2,4),(3,2),(3,4),(4,2),(4,3),(4,4)), }}},
                    {'name':'Fortress', 'params':{'dimensions':(7,7), 'positions':{'1':((0,0),(0,1),(0,2),(0,3),(0,4),(0,5),(0,6),(1,3)), '2':((6,2),(6,3),(6,4),(5,2),(5,3),(5,4)), '-1':((6,1),(6,5),(5,1),(5,5),(4,1),(4,2),(4,4),(4,5)), }}},
                    {'name':'8x8 Standard', 'params':{'dimensions':(8,8), 'positions':{'1':((0,0),(7,7)), '2':((7,0),(0,7)), }}},
                    {'name':'8x8 Random', 'params':{'dimensions':(8,8), 'random_walls': 10, 'positions':{'1':((0,0),(7,7)), '2':((7,0),(0,7)), }}},
                    {'name':'8x8 Bridge', 'params':{'dimensions':(8,8), 'positions':{'1':((0,0),(7,7)), '2':((7,0),(0,7)), '-1': ((3,0),(3,1),(3,2),(3,5),(3,6),(3,7),(4,0),(4,1),(4,2),(4,5),(4,6),(4,7))}}},
                    {'name':'8x8 Pillars', 'params':{'dimensions':(8,8), 'positions':{'1':((0,0),(7,7)), '2':((7,0),(0,7)), '-1': ((1,1),(1,2),(2,1),(2,2),(5,1),(5,2),(6,1),(6,2),(5,5),(5,6),(6,5),(6,6),(1,5),(1,6),(2,5),(2,6))}}},
                    {'name':'9x9 Standard', 'params':{'dimensions':(9,9), 'positions':{'1':((0,0),(8,8)), '2':((8,0),(0,8)), }}},
                    {'name':'9x9 Random', 'params':{'dimensions':(9,9), 'random_walls': 14, 'positions':{'1':((0,0),(8,8)), '2':((8,0),(0,8)), }}},
                    {'name':'9x9 Eyes', 'params':{'dimensions':(9,9), 'positions':{'1':((0,0),(8,8)), '2':((0,8),(8,0)), '-1':((0,1),(1,1),(1,0),(7,0),(7,1),(8,1),(0,7),(1,7),(1,8),(7,8),(7,7),(8,7),(3,3),(3,4),(3,5),(4,3),(4,5),(5,3),(5,4),(5,5)), }}},
                    {'name':'6x6x6', 'params':{'dimensions':(6,6,6), 'positions':{'1':((0,0,0),(5,5,5)), '2':((0,5,5),(5,5,0),(0,5,0)), }}},
                    {'name':'6x6x6 Random', 'params':{'dimensions':(6,6,6), 'random_walls': 20, 'positions':{'1':((0,0,0),(5,5,5)), '2':((0,5,5),(5,5,0),(0,5,0)), }}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}},
            {'name':'Hard', 'params':{'depth':3}},
            {'name':'Very Hard', 'params':{'depth':4}},
           ],
    },
    {'name': 'Reversi',
     'variations': [{'name':'Standard', 'params':{'dimensions':(8,8), 'positions':{'1':((3,3),(4,4)), '2':((3,4),(4,3)), }}},
                    {'name':'No Corners', 'params':{'dimensions':(8,8), 'positions':{'1':((3,3),(4,4)), '2':((3,4),(4,3)), '-1':((0,0),(0,7),(7,0),(7,7)) }}},
                    {'name':'Random', 'params':{'dimensions':(8,8), 'random_walls': 6, 'positions':{'1':((3,3),(4,4)), '2':((3,4),(4,3)), }}},
                    {'name':'6x6x6', 'params':{'dimensions':(6,6,6), 'positions':{'1':((2,2,2),(2,3,3),(3,2,3),(3,3,2)), '2':((3,2,2),(3,3,3),(2,2,3), (2,3,2)), }}},
                    {'name':'6x6x6 Random', 'params':{'dimensions':(6,6,6), 'random_walls': 12, 'positions':{'1':((2,2,2),(2,3,3),(3,2,3),(3,3,2)), '2':((3,2,2),(3,3,3),(2,2,3), (2,3,2)), }}}

                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}},
            {'name':'Hard', 'params':{'depth':3}},
           ],
    },
    {'name': 'Dominion',
     'variations': [{'name':'Standard', 'params':{'dimensions':(8,8), 'positions':{
                         '1':((3,3),(4,4),(0,7),(7,0)), 
                         '2':((3,4),(4,3),(0,0),(7,7)), }}},
                    {'name':'6x6x6', 'params':{'dimensions':(6,6,6), 'positions':{
                         '1':((2,2,2),(2,3,3),(3,2,3),(3,3,2),(5,5,5),(5,0,0),(0,5,0),(0,0,5)), 
                         '2':((3,2,2),(3,3,3),(2,2,3),(2,3,2),(0,0,0),(0,5,5),(5,0,5),(5,5,0)), }}}
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}},
            {'name':'Hard', 'params':{'depth':3}},
           ],
    },
    {'name': 'Checkers',
     'variations': [{'name':'Standard', 'params':{'dimensions':(8,8), 'positions':{
     	                 '1':((0,0),(2,0),(4,0),(6,0),(1,1),(3,1),(5,1),(7,1),(0,2),(2,2),(4,2),(6,2)), 
     	                 '2':((1,7),(3,7),(5,7),(7,7),(0,6),(2,6),(4,6),(6,6),(1,5),(3,5),(5,5),(7,5)), }}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':2}},
            {'name':'Medium', 'params':{'depth':4}},
            {'name':'Hard', 'params':{'depth':6}},
           ],
    },
    {'name': 'ThinkAhead', 'display_name': 'Think Ahead',
     'variations': [{'name':'Standard', 'params':{'dimensions':(8,8)}},
                    {'name':'6x6x6', 'params':{'dimensions':(6,6,6)}}
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':2}},
            {'name':'Medium', 'params':{'depth':3}},
            {'name':'Hard', 'params':{'depth':5}},
            {'name':'Very Hard', 'params':{'depth':7}},
           ],
    },
    {'name': 'Gomoku',
     'variations': [{'name':'Standard', 'params':{'dimensions':(8,8)}},
                    {'name':'6x6x6', 'params':{'dimensions':(6,6,6)}}
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}}
           ],
    },
    {'name': 'Pente',
     'variations': [{'name':'9x9', 'params':{'dimensions':(9, 9)}},
                    {'name':'13x13', 'params':{'dimensions':(13, 13)}},
                    {'name':'Keryo 9x9', 'params':{'dimensions':(9, 9), 'captures': [2,3], 'win_score': 15}},
                    {'name':'Keryo 13x13', 'params':{'dimensions':(13, 13), 'captures': [2,3], 'win_score': 15}},
                    {'name':'6x6x6', 'params':{'dimensions':(6, 6, 6)}},
                    {'name':'Keryo 6x6x6', 'params':{'dimensions':(6, 6, 6), 'captures': [2,3], 'win_score': 15}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}}
           ],
    },
    {'name': 'ConnectFour', 'display_name': 'Connect Four',
     'variations': [{'name':'Standard', 'params':{'dimensions':(8,8)}},
                    {'name':'6x6x6', 'params':{'dimensions':(6,6,6)}}
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':2}},
            {'name':'Medium', 'params':{'depth':3}},
            {'name':'Hard', 'params':{'depth':4}},
           ],
    },
    {'name': 'Pentago',
     'variations': [{'name':'Standard', 'params':{'dimensions':(6,6)}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}},
            {'name':'Hard', 'params':{'depth':3}},
           ],
    },
    {'name': 'Chess',
     'variations': [{'name':'Standard', 'params':{'dimensions':(8,8)}},
                    {'name':'Chess256', 'params':{'dimensions':(8,8), 'random23Pawns':1}},
                    {'name':'King\'s Corner', 'params':{'dimensions':(8,8), 'kingsCorner':1}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}},
            {'name':'"Hard"', 'params':{'depth':3}},
           ],
    },
    {'name': 'Cephalopod',
     'variations': [{'name':'Standard', 'params':{'dimensions':(5,5)}},
                    #{'name':'6x6', 'params':{'dimensions':(6,6)}},
                    #{'name':'5x5x5', 'params':{'dimensions':(5,5,5)}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':2}},
            {'name':'Medium', 'params':{'depth':3}},
            {'name':'Hard', 'params':{'depth':4}},    
           ],    
    },
    {'name': 'Diagonals',
     'variations': [{'name':'Standard', 'params':{'dimensions':(8,8)}},
                    {'name':'6x6', 'params':{'dimensions':(6,6)}},
                    {'name':'5x5x5', 'params':{'dimensions':(5,5,5)}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}},
            {'name':'Hard', 'params':{'depth':3}},    
           ],    
    },
    {'name': 'Tonga',
     'variations': [{'name':'Standard', 'params':{'dimensions':(9,9)}},
                    {'name':'Random', 'params':{'dimensions':(9,9), 'random_walls':10, }},
                    {'name':'6x6', 'params':{'dimensions':(6,6)}},
                    {'name':'5x5x5', 'params':{'dimensions':(5,5,5)}},
                    {'name':'5x5x5 Random', 'params':{'dimensions':(5,5,5), 'random_walls': 12}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Hard', 'params':{'depth':2}},
           ],    
    },
    {'name': 'Hexapawn',
     'variations': [{'name':'6x6', 'params':{'dimensions':(6,6), 'moves': ['forward'], 'captures': ['diagonal']}},
                    {'name':'8x8', 'params':{'dimensions':(8,8), 'moves': ['forward'], 'captures': ['diagonal']}},
                    {'name':'6x6 Berolina', 'params':{'dimensions':(6,6), 'moves': ['diagonal'], 'captures': ['forward']}},
                    {'name':'6x6 Berolina+', 'params':{'dimensions':(6,6), 'moves': ['diagonal'], 'captures': ['forward', 'side']}},
                    {'name':'5x5x5', 'params':{'dimensions':(5,5,5), 'moves': ['forward'], 'captures': ['diagonal']}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}},
            {'name':'Hard', 'params':{'depth':3}},
            {'name':'Very Hard', 'params':{'depth':4}},
           ],    
    },
    {'name': 'Breakthrough', 'class': 'Hexapawn',
     'variations': [{'name':'Standard', 'params':{'dimensions':(8,8), 'fillRows': 2, 'moves': ['forward','diagonal'], 'captures': ['diagonal']}},
                    {'name':'6x6x6', 'params':{'dimensions':(6,6,6), 'fillRows': 2, 'moves': ['forward','diagonal'], 'captures': ['diagonal']}},],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}},
            {'name':'Hard', 'params':{'depth':3}},
            {'name':'Very Hard', 'params':{'depth':4}},
           ],    
    },
    {'name': 'Amazons',
     'variations': [{'name':'Standard', 'params':{'dimensions':(10,10), 
                         'positions':{'1':((0,3),(3,0),(6,0),(9,3)), '2':((0,6),(3,9),(6,9),(9,6)), }}},
                    {'name':'6x6x6', 'params':{'dimensions':(6,6,6), 
                         'positions':{'1':((0,1,0),(0,1,5),(5,1,0),(5,1,5),(2,0,3)), '2':((0,4,0),(5,4,0),(0,4,5),(5,4,5),(3,5,2)), }}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
           ],
    },
    {'name': 'LinesOfAction', 'display_name': 'Lines Of Action',
     'variations': [{'name':'Standard', 'params':{'dimensions':(8,8), 
                         'positions':{'2':((0,1),(0,2),(0,3),(0,4),(0,5),(0,6),(7,1),(7,2),(7,3),(7,4),(7,5),(7,6)), 
                                      '1':((1,0),(2,0),(3,0),(4,0),(5,0),(6,0),(1,7),(2,7),(3,7),(4,7),(5,7),(6,7)), }}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}},
            {'name':'Hard', 'params':{'depth':3}},
           ],
    },
    {'name': 'Zonesh',
     'variations': [{'name':'6x6', 'params':{'dimensions':(6,6), 'zone_size': 4,}},
                    {'name':'5x5x5', 'params':{'dimensions':(5,5,5), 'zone_size': 3,}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}},
            {'name':'Hard', 'params':{'depth':3}},
           ],
    },
    {'name': 'Symbio',
     'variations': [{'name':'Standard', 'params':{'dimensions':(8,8), 
                         'positions':{'1':((1,1),(1,2),(2,1),(6,6),(6,5),(5,6)), '2':((1,6),(1,5),(2,6),(6,1),(5,1),(6,2))}}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}},
            {'name':'Hard', 'params':{'depth':3}},
           ],
    },
    {'name': 'Abande',
     'variations': [{'name':'Standard', 'params':{'dimensions':(7,7),}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}},
            {'name':'Hard', 'params':{'depth':3}},
           ],
    },
    {'name': 'ThreeSixNine', 'display_name': '3-6-9',
     'variations': [{'name':'9x9', 'params':{'dimensions':(9,9),}},
                    {'name':'6x6', 'params':{'dimensions':(6,6),}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}},
            {'name':'Hard', 'params':{'depth':3}},
           ],
    },
    {'name': 'Forms',
     'variations': [{'name':'8x8', 'params':{'dimensions':(8,8),}},
                   ],
     'ai': [{'name':'Easy', 'params':{'depth':1}},
           ],
    },
    {'name': 'PegJump', 'display_name': 'Peg Jump',
     'variations': [{'name':'English', 'params':{'dimensions':(7,7), 'positions':{0:((3,3)), 
                         '1':((2,0),(3,0),(4,0),(2,1),(3,1),(4,1),(0,2),(1,2),(2,2),(3,2),(4,2),(5,2),(6,2),(0,3),(1,3),(2,3),(4,3),(5,3),(6,3),(0,4),(1,4),(2,4),(3,4),(4,4),(5,4),(6,4),(2,5),(3,5),(4,5),(2,6),(3,6),(4,6)), 
                        '-1':((0,0),(0,1),(1,0),(1,1),(0,5),(0,6),(1,5),(1,6),(5,0),(6,0),(5,1),(6,1),(5,5),(5,6),(6,5),(6,6)) }}},
                   {'name':'European', 'params':{'dimensions':(7,7), 'positions':{0:((3,3)), 
                         '1':((2,0),(3,0),(4,0),(2,1),(3,1),(4,1),(0,2),(1,2),(2,2),(3,2),(4,2),(5,2),(6,2),(0,3),(1,3),(2,3),(4,3),(5,3),(6,3),(0,4),(1,4),(2,4),(3,4),(4,4),(5,4),(6,4),(2,5),(3,5),(4,5),(2,6),(3,6),(4,6),(1,1),(1,5),(5,5),(5,1)), 
                        '-1':((0,0),(0,1),(1,0),(0,5),(0,6),(1,6),(5,0),(6,0),(6,1),(5,6),(6,5),(6,6)) }}},
                   ],
                   
     'ai': [],    
    },
    {'name': 'Concentration',
     'variations': [{'name':'6x6', 'params':{'dimensions':(6,6)},},
                    {'name':'8x8', 'params':{'dimensions':(8,8)},},
                    {'name':'4x4x4', 'params':{'dimensions':(4,4,4)},},
                   ],
                   
     'ai': [],    
    },
    {'name': 'SetsPG', 'display_name': 'Sets',
     'variations': [{'name':'Standard', 'params':{'dimensions':(4,4)},},
                   ],
                   
     'ai': [{'name':'Demo', 'params':{'depth':1}},
           ],    
    },
    {'name': 'Lines',
     'variations': [{'name':'Standard', 'params':{'dimensions':(9,9)},},
                    {'name':'11x11/8', 'params':{'dimensions':(11,11), 'num_colors':8},},
                    {'name':'7x7/5', 'params':{'dimensions':(7,7), 'num_colors':5},},
                    {'name':'5x5x5', 'params':{'dimensions':(5,5,5), 'line_length':4},},
                   ],       
     'ai': [],    
    },
    {'name': 'SameGame', 'display_name': 'Same Game',
     'variations': [{'name':'Standard', 'params':{'dimensions':(8,8), 'num_colors':4, 'num_players': 1},},
                    #{'name':'Standard Vs', 'params':{'dimensions':(8,8), 'num_colors':4, 'num_players': 2},},
                    {'name':'10x10/4 colors', 'params':{'dimensions':(10,10), 'num_colors':4, 'num_players': 1},},
                    {'name':'10x10/6 colors', 'params':{'dimensions':(10,10), 'num_colors':6, 'num_players': 1},},
                    #{'name':'10x10/6 Vs', 'params':{'dimensions':(10,10), 'num_colors':6, 'num_players': 2},},
                   ],       
     'ai': [{'name':'Easy', 'params':{'depth':1}},
            {'name':'Medium', 'params':{'depth':2}},
            {'name':'Hard', 'params':{'depth':3}},
            {'name':'Very Hard', 'params':{'depth':4}},
           ],
    },
    {'name': 'LightsOut', 'display_name': 'Lights Out',
     'variations': [{'name':'Standard', 'params':{'dimensions':(5,5)},},
                    {'name':'7x7', 'params':{'dimensions':(7,7)},},
                    {'name':'5x5x5', 'params':{'dimensions':(5,5,5)},},
                   ],       
     'ai': [],    
    },
]
